<?php
namespace nur\sery\db\mysql;

use nur\sery\db\_private\_base;
use nur\sery\ValueException;

class _query_base extends _base {
  protected static function verifix(&$sql, ?array &$params=null): void {
    if (is_array($sql)) {
      $prefix = $sql[0] ?? null;
      if ($prefix === null) {
        throw new ValueException("requête invalide");
      } elseif (_query_create::isa($prefix)) {
        $sql = _query_create::parse($sql, $params);
      } elseif (_query_select::isa($prefix)) {
        $sql = _query_select::parse($sql, $params);
      } elseif (_query_insert::isa($prefix)) {
        $sql = _query_insert::parse($sql, $params);
      } elseif (_query_update::isa($prefix)) {
        $sql = _query_update::parse($sql, $params);
      } elseif (_query_delete::isa($prefix)) {
        $sql = _query_delete::parse($sql, $params);
      } elseif (_query_generic::isa($prefix)) {
        $sql = _query_generic::parse($sql, $params);
      } else {
        throw ValueException::invalid_kind($sql, "query");
      }
    } elseif (!is_string($sql)) {
      $sql = strval($sql);
    }
  }
}
